unit IntDCT;

  interface

    type dctelem=integer;
         ardata=array[0..63] of dctelem;
    const c181=181;
          c98=98;
          c139=139;
          c334=334;
          c362=362;
          c473=473;
          c277=277;
          cm669=-669;

    procedure FlDCT(var data:ardata);
    procedure FlIDCT(var data:ardata);

  implementation

    procedure FlDCT(var data:ardata);
      var tmp0,tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7:dctelem;
          tmp10,tmp11,tmp12,tmp13:dctelem;
          z1,z2,z3,z4,z5,z11,z13:dctelem;
          ctr:integer;
          dp:integer;
      begin
        dp:=0;
        for ctr:=7 downto 0 do
          begin
            tmp0:=data[dp+0]+data[dp+7];tmp7:=data[dp+0]-data[dp+7];
            tmp1:=data[dp+1]+data[dp+6];tmp6:=data[dp+1]-data[dp+6];
            tmp2:=data[dp+2]+data[dp+5];tmp5:=data[dp+2]-data[dp+5];
            tmp3:=data[dp+3]+data[dp+4];tmp4:=data[dp+3]-data[dp+4];
            tmp10:=tmp0+tmp3;tmp13:=tmp0-tmp3;
            tmp11:=tmp1+tmp2;tmp12:=tmp1-tmp2;
            data[dp+0]:=tmp10+tmp11;data[dp+4]:=tmp10-tmp11;
            z1:=(tmp12+tmp13)*c181 div 256;
            data[dp+2]:=tmp13+z1;data[dp+6]:=tmp13-z1;
            tmp10:=tmp4+tmp5;tmp11:=tmp5+tmp6;tmp12:=tmp6+tmp7;
            z5:=(tmp10-tmp12)*c98 div 256;z2:=tmp10*c139 div 256+z5;
            z4:=tmp12*c334 div 256+z5;z3:=tmp11*c181 div 256;
            z11:=tmp7+z3;z13:=tmp7-z3;
            data[dp+5]:=z13+z2;data[dp+3]:=z13-z2;
            data[dp+1]:=z11+z4;data[dp+7]:=z11-z4;
            dp:=dp+8;
          end;
        dp:=0;
        for ctr:=7 downto 0 do
          begin
            tmp0:=data[dp+0]+data[dp+8*7];tmp7:=data[dp+0]-data[dp+8*7];
            tmp1:=data[dp+8*1]+data[dp+8*6];tmp6:=data[dp+8*1]-data[dp+8*6];
            tmp2:=data[dp+8*2]+data[dp+8*5];tmp5:=data[dp+8*2]-data[dp+8*5];
            tmp3:=data[dp+8*3]+data[dp+8*4];tmp4:=data[dp+8*3]-data[dp+8*4];
            tmp10:=tmp0+tmp3;tmp13:=tmp0-tmp3;
            tmp11:=tmp1+tmp2;tmp12:=tmp1-tmp2;
            data[dp+8*0]:=tmp10+tmp11;data[dp+8*4]:=tmp10-tmp11;
            z1:=(tmp12+tmp13)*c181 div 256;
            data[dp+8*2]:=tmp13+z1;data[dp+8*6]:=tmp13-z1;
            tmp10:=tmp4+tmp5;tmp11:=tmp5+tmp6;tmp12:=tmp6+tmp7;
            z5:=(tmp10-tmp12)*c98 div 256;z2:=tmp10*c139 div 256+z5;
            z4:=tmp12*c334 div 256+z5;z3:=tmp11*c181 div 256;
            z11:=tmp7+z3;z13:=tmp7-z3;
            data[dp+8*5]:=z13+z2;data[dp+8*3]:=z13-z2;
            data[dp+8*1]:=z11+z4;data[dp+8*7]:=z11-z4;
            dp:=dp+1;
          end;
      end;

    procedure FliDCT(var data:ardata);
      var tmp0,tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7:dctelem;
          tmp10,tmp11,tmp12,tmp13:dctelem;
          z5,z10,z11,z12,z13:dctelem;
          ctr:integer;
          dp:integer;
      begin
        dp:=0;
        for ctr:=7 downto 0 do
          begin
            tmp0:=data[dp+8*0];tmp1:=data[dp+8*2];
            tmp2:=data[dp+8*4];tmp3:=data[dp+8*6];
            tmp10:= tmp0+tmp2;tmp11:= tmp0-tmp2;
            tmp13:=tmp1+tmp3;
            tmp12:=(tmp1-tmp3)*c362 div 256-tmp13;
            tmp0:=tmp10+tmp13;tmp3:=tmp10-tmp13;
            tmp1:=tmp11+tmp12;tmp2:=tmp11-tmp12;
            tmp4:=data[dp+8*1];tmp5:=data[dp+8*3];
            tmp6:=data[dp+8*5];tmp7:=data[dp+8*7];
            z13:=tmp6+tmp5;z10:=tmp6-tmp5;
            z11:=tmp4+tmp7;z12:=tmp4-tmp7;
            tmp7:=z11+z13;
            tmp11:=(z11-z13)*c362 div 256;
            z5:=(z10+z12)*c473 div 256;
            tmp10:=c277*z12 div 256-z5;
            tmp12:=cm669*z10 div 256+z5;
            tmp6:=tmp12-tmp7;tmp5:=tmp11-tmp6;tmp4:=tmp10+tmp5;
            data[dp+0*8]:=tmp0+tmp7;data[dp+7*8]:=tmp0-tmp7;
            data[dp+1*8]:=tmp1+tmp6;data[dp+6*8]:=tmp1-tmp6;
            data[dp+2*8]:=tmp2+tmp5;data[dp+5*8]:=tmp2-tmp5;
            data[dp+4*8]:=tmp3+tmp4;data[dp+3*8]:=tmp3-tmp4;
            inc(dp);
          end;
        dp:=0;
        for ctr:=0 to 7 do
          begin
            tmp10:=data[dp+0]+data[dp+4];tmp11:=data[dp+0]-data[dp+4];
            tmp13:=data[dp+2]+data[dp+6];
            tmp12:=(data[dp+2]-data[dp+6])*c362 div 256-tmp13;
            tmp0:=tmp10+tmp13;tmp3:=tmp10-tmp13;
            tmp1:=tmp11+tmp12;tmp2:=tmp11-tmp12;
            z13:=data[dp+5]+data[dp+3];z10:=data[dp+5]-data[dp+3];
            z11:=data[dp+1]+data[dp+7];z12:=data[dp+1]-data[dp+7];
            tmp7:=z11+z13;
            tmp11:=(z11-z13)*c362 div 256;
            z5:=(z10+z12)*c473 div 256;
            tmp10:=c277*z12 div 256-z5;
            tmp12:=cm669*z10 div 256+z5;
            tmp6:=tmp12-tmp7;tmp5:=tmp11-tmp6;tmp4:=tmp10+tmp5;
            data[dp+0]:=tmp0+tmp7;data[dp+7]:=tmp0-tmp7;
            data[dp+1]:=tmp1+tmp6;data[dp+6]:=tmp1-tmp6;
            data[dp+2]:=tmp2+tmp5;data[dp+5]:=tmp2-tmp5;
            data[dp+4]:=tmp3+tmp4;data[dp+3]:=tmp3-tmp4;
            dp:=dp+8;
          end;
      end;
  end.
